import java.io.*;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.ParserConfigurationException;
import org.w3c.dom.*;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.xml.sax.SAXException;
import java.lang.Boolean;

public class readXMLtoDOM
{
    //
    // Simple demonstration of document construction with DOM,
    // with deep and shallow modes of cloning. 
    //
    // Also, that real applications have real exception handling! 
    //
    public static void main (String argv [])
    throws IOException, DOMException, ParserConfigurationException, TransformerConfigurationException, TransformerException, SAXException
    {
        DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance ();
	DocumentBuilder db = dbf.newDocumentBuilder ();
	Document doc = db.newDocument ();
        Document document = db.parse( new File(argv[0]) );
	Element root = doc.createElement ("root");
	Attr		tmp;
	Writer		out = new OutputStreamWriter (System.out);

        //DocumentFragment doc = docH.createDocumentFragment();
	doc.appendChild (root);

	out.write ("No children ...\n");
	out.write ("\n");
	out.flush ();
	doClones (out, root);

	root.appendChild (doc.createElement ("header"));
	root.appendChild (doc.createTextNode ("\n  some data is text\n  "));
	root.appendChild (doc.createElement ("footer"));
        //doc.appendChild ( document );

	// White space is added to help people read XML documents.
	// In content models with text, it's not ignorable; in
	// other content models, applications can discard it.
	Text		text;

	// The portable way to get the first item from the root is
	// root.getChildren ().item (0) ... and you'd need to test for
	// a null list of children too, so it's actually multiple lines
	// when coded safely.
	text = doc.createTextNode ("\n");
	root.insertBefore (text, root.getFirstChild ());

	text = doc.createTextNode ("\n");
	root.appendChild (text);

	out.write ("Cloning ... mixed content model ...\n");
	out.write ("\n");
	out.flush ();
	doClones (out, root);
    
	// This is one way to create an attribute ...
	tmp = doc.createAttribute ("attr1");
	tmp.setNodeValue ("value of attribute 1");
	root.getAttributes ().setNamedItem (tmp);

	// ... and this is another (simpler, and far preferable)
	root.setAttribute ("attr2", "another string");

	out.write ("Cloning with attributes... and attributes...\n");
	out.write ("\n");
	out.flush ();
	doClones (out, root);

        printDocument(out, root); 

        //DocumentFragment docF = doc.createDocumentFragment();
        //Node inode = document.importNode( root, true);
        //printDocument(out, clone );
        Element root2 = document.getDocumentElement();
        Node inode = doc.importNode( root2, true);
        Element clone = (Element)inode.cloneNode (true);
        //document.appendChild( root2 );

        root.appendChild( clone );
        TransformerFactory tFactory =
            TransformerFactory.newInstance();
        
        Transformer transformer = tFactory.newTransformer();

        DOMSource source = new DOMSource(doc);
        StreamResult result = new StreamResult(System.out);
        transformer.transform(source, result);

        System.exit (0);
    }

    private static void doClones (Writer out, Element root)
    throws IOException
    {
        Element clone1;
    
        clone1 =  (Element)root.cloneNode (false);
    
        out.write ("Finished SHALLOW CLONE:\t");
	out.write ("\n");
	out.flush ();

        Element clone2;
    
        clone2 =  (Element)root.cloneNode (true);
    
        out.write ("Finished DEEP CLONE:\t");
	out.write ("\n");
	out.flush ();

        //System.out.println("clone1:" + clone1.getNodeName());
        //System.out.println("clone2:" + clone2.getNodeName());
    }
    private static void printDocument (Writer out, Element root)
    throws IOException
    {
        out.write ("Element(Tag):" + root.getTagName());
        out.write ("\n");
        out.flush ();
    }
}
